( function( $ ) {

	/**
	 * Main plugin controller.
	 */
	var PrivateArea = function() {

		/**
		 * Change clause.
		 */
		this.changeClause = function() {
			var criterion = $( this ).val(),
				container = $( this ).parents( 'td' ).first();

			$( '[data-private-area-access-controller-value]', container ).hide();
			$( '[data-private-area-access-controller-value="' + criterion + '"]', container ).show();
		};

		/**
		 * Event binding.
		 */
		this.bind = function() {
			// Instantiate multi-select components.
			$( '.private-area-multiselect' ).select2();

			// When changing criteria, also display their own fields.
			$( '[data-criterion]' ).on( 'change', this.changeClause );
			$( '[data-criterion]' ).each( function() {
				$( this ).trigger( 'change' );
			} );

			// Fire up help tooltips.
			$( '.private-area-help' ).tipTip( {
				defaultPosition: 'top',
				fadeIn: 0,
				fadeOut: 0
			} );
		};

		/**
		 * Initialization.
		 */
		this.init = function() {
			this.bind();
		};

		this.init();

	};

	( new PrivateArea() );

} )( jQuery );
